如何解决LeetCode 312题:戳气球(难度:困难)的算法问题?

更新于
2026-10-09 12:09:05
1阅读来源:SEO资讯
  • 内容介绍
  • 文章标签
  • 相关推荐

本文共计705个文字,预计阅读时间需要3分钟。

如何解决LeetCode 312题:戳气球(难度:困难)的算法问题?

分治 + 动态规划,dp[i][j]=maxCoins(nums[i]) + nums[j] + nums[i-1],表示从第i个气球到第j个气球的最大值。我们所求的答案就是ans=dp[1][n]。一、题目大意:有n个气球,每个气球都有一个分数值,我们需要通过选择一些气球并使其爆破来获得最高分数。爆破一个气球会获得该气球的分数值,并且如果这个气球相邻的气球被爆破,那么这两个气球的分数值也会被加到总分中。我们的目标是选择一组气球,使得总分最大。

如何解决LeetCode 312题:戳气球(难度:困难)的算法问题?

分治+动态规划,dp[i][j] = maxCoins(nums[i]~nums[j]) 表示从第i个气球到第j个气球的最大值,我们所求答案就是ans = dp[1][n]。 一、题目大意

标签: 分治

leetcode.cn/problems/burst-balloons

有 n 个气球,编号为0 到 n - 1,每个气球上都标有一个数字,这些数字存在数组nums中。

现在要求你戳破所有的气球。戳破第 i 个气球,你可以获得nums[i - 1] * nums[i] * nums[i + 1] 枚硬币。这里的 i - 1 和 i + 1 代表和i相邻的两个气球的序号。如果 i - 1或 i + 1 超出了数组的边界,那么就当它是一个数字为 1 的气球。

求所能获得硬币的最大数量。

示例 1:

输入:nums = [3,1,5,8]
输出:167
解释:
nums = [3,1,5,8] --> [3,5,8] --> [3,8] --> [8] --> []
coins = 315 + 358 + 138 + 181 = 167

示例 2:

输入:nums = [1,5]
输出:10

提示:

  • n == nums.length
  • 1 <= n <= 300
  • 0 <= nums[i] <= 100
二、解题思路

分治+动态规划,dp[i][j] = maxCoins(nums[i]~nums[j]) 表示从第i个气球到第j个气球的最大值,我们所求答案就是ans = dp[1][n]。i与j之间找一个气球k,i到k-1之间最大分数,k+1与j之间最大值,最后打破气球k。所以动态转移方程为:dp[i][j] = max(c[i][k-1] + nums[k-1]nums[k]nums[k+1]+c[k+1][j])。

三、解题方法 3.1 Java实现

public class Solution { public int maxCoins(int[] nums) { int n = nums.length; int[] nums2 = new int[n + 2]; nums2[0] = 1; nums2[n + 1] = 1; for (int i = 0; i < n; i++) { nums2[i + 1] = nums[i]; } int[][] dp = new int[n + 2][n + 2]; for (int l = 1; l <= n; l++) { for (int i = 1; i <= n - l + 1; i++) { int j = i + l - 1; for (int k = i; k <= j; k++) { dp[i][j] = Math.max(dp[i][j], dp[i][k - 1] + nums2[i - 1] * nums2[k] * nums2[j + 1] + dp[k + 1][j]); } } } return dp[1][n]; } } 四、总结小记

  • 2022/7/10 两地奔波的一天

本文共计705个文字,预计阅读时间需要3分钟。

如何解决LeetCode 312题:戳气球(难度:困难)的算法问题?

分治 + 动态规划,dp[i][j]=maxCoins(nums[i]) + nums[j] + nums[i-1],表示从第i个气球到第j个气球的最大值。我们所求的答案就是ans=dp[1][n]。一、题目大意:有n个气球,每个气球都有一个分数值,我们需要通过选择一些气球并使其爆破来获得最高分数。爆破一个气球会获得该气球的分数值,并且如果这个气球相邻的气球被爆破,那么这两个气球的分数值也会被加到总分中。我们的目标是选择一组气球,使得总分最大。

如何解决LeetCode 312题:戳气球(难度:困难)的算法问题?

分治+动态规划,dp[i][j] = maxCoins(nums[i]~nums[j]) 表示从第i个气球到第j个气球的最大值,我们所求答案就是ans = dp[1][n]。 一、题目大意

标签: 分治

leetcode.cn/problems/burst-balloons

有 n 个气球,编号为0 到 n - 1,每个气球上都标有一个数字,这些数字存在数组nums中。

现在要求你戳破所有的气球。戳破第 i 个气球,你可以获得nums[i - 1] * nums[i] * nums[i + 1] 枚硬币。这里的 i - 1 和 i + 1 代表和i相邻的两个气球的序号。如果 i - 1或 i + 1 超出了数组的边界,那么就当它是一个数字为 1 的气球。

求所能获得硬币的最大数量。

示例 1:

输入:nums = [3,1,5,8]
输出:167
解释:
nums = [3,1,5,8] --> [3,5,8] --> [3,8] --> [8] --> []
coins = 315 + 358 + 138 + 181 = 167

示例 2:

输入:nums = [1,5]
输出:10

提示:

  • n == nums.length
  • 1 <= n <= 300
  • 0 <= nums[i] <= 100
二、解题思路

分治+动态规划,dp[i][j] = maxCoins(nums[i]~nums[j]) 表示从第i个气球到第j个气球的最大值,我们所求答案就是ans = dp[1][n]。i与j之间找一个气球k,i到k-1之间最大分数,k+1与j之间最大值,最后打破气球k。所以动态转移方程为:dp[i][j] = max(c[i][k-1] + nums[k-1]nums[k]nums[k+1]+c[k+1][j])。

三、解题方法 3.1 Java实现

public class Solution { public int maxCoins(int[] nums) { int n = nums.length; int[] nums2 = new int[n + 2]; nums2[0] = 1; nums2[n + 1] = 1; for (int i = 0; i < n; i++) { nums2[i + 1] = nums[i]; } int[][] dp = new int[n + 2][n + 2]; for (int l = 1; l <= n; l++) { for (int i = 1; i <= n - l + 1; i++) { int j = i + l - 1; for (int k = i; k <= j; k++) { dp[i][j] = Math.max(dp[i][j], dp[i][k - 1] + nums2[i - 1] * nums2[k] * nums2[j + 1] + dp[k + 1][j]); } } } return dp[1][n]; } } 四、总结小记

  • 2022/7/10 两地奔波的一天